use std::fmt;
use std::str;
use std::string::FromUtf8Error;

/// An error that occurred while using a finite state transducer.
///
/// This enum is non-exhaustive. New variants may be added to it in
/// compatible releases.
#[non_exhaustive]
pub enum Error {
    /// An unexpected error occurred while reading a finite state transducer.
    /// Usually this occurs because the data is corrupted or is not actually
    /// a finite state transducer serialized by this library.
    Format {
        /// The number of bytes given to the FST constructor.
        size: usize,
    },
    /// A duplicate key was inserted into a finite state transducer, which is
    /// not allowed.
    DuplicateKey {
        /// The duplicate key.
        got: Vec<u8>,
    },
    /// A key was inserted out of order into a finite state transducer.
    ///
    /// Keys must always be inserted in lexicographic order.
    OutOfOrder {
        /// The last key successfully inserted.
        previous: Vec<u8>,
        /// The key that caused this error to occur.
        got: Vec<u8>,
    },
    /// An error that occurred when trying to decode a UTF-8 byte key.
    FromUtf8(FromUtf8Error),
}

impl fmt::Display for Error {
    fn fmt(&self, f: &mut fmt::Formatter<'_>) -> fmt::Result {
        match *self {
            Error::FromUtf8(ref err) => err.fmt(f),
            Error::Format { size } => write!(
                f,
                "\
Error opening FST with size {} bytes: An unknown error occurred. This \
usually means you're trying to read data that isn't actually an encoded FST.",
                size
            ),
            Error::DuplicateKey { ref got } => write!(
                f,
                "Error inserting duplicate key: '{}'.",
                format_bytes(&*got)
            ),
            Error::OutOfOrder { ref previous, ref got } => write!(
                f,
                "\
Error inserting out-of-order key: '{}'. (Previous key was '{}'.) Keys must be \
inserted in lexicographic order.",
                format_bytes(&*got),
                format_bytes(&*previous)
            ),
        }
    }
}

impl fmt::Debug for Error {
    fn fmt(&self, f: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(self, f)
    }
}

impl std::error::Error for Error {
    fn source(&self) -> Option<&(dyn std::error::Error + 'static)> {
        match *self {
            Error::FromUtf8(ref err) => Some(err),
            _ => None,
        }
    }
}

impl From<FromUtf8Error> for Error {
    #[inline]
    fn from(err: FromUtf8Error) -> Error {
        Error::FromUtf8(err)
    }
}

/// Attempt to convert an arbitrary byte string to a more convenient display
/// form.
///
/// Essentially, try to decode the bytes as UTF-8 and show that. Failing that,
/// just show the sequence of bytes.
fn format_bytes(bytes: &[u8]) -> String {
    match str::from_utf8(bytes) {
        Ok(s) => s.to_owned(),
        Err(_) => format!("{:?}", bytes),
    }
}
